

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

    

<html lang="en-US" dir="ltr" xmlns="http://www.w3.org/1999/xhtml">
<head><script src="https://c.s-microsoft.com/mscc/statics/mscc-0.4.2.min.js"></script><script src="/_static/tfs/M165_20200226.19/_scripts/TFS/min/Gallery/Client/Common/ManageCookieDrop.js"></script><link rel="Stylesheet" href="https://c.s-microsoft.com/mscc/statics/mscc-0.4.2.min.css" /><title>
	
    All categories Extensions - Visual Studio Marketplace

</title>
    <meta name="description" content="All&#32;categories&#32;extensions&#32;for&#32;Visual&#32;Studio&#32;on&#32;marketplace.visualstudio.com" /><meta name="keywords" content="Visual&#32;Studio,&#32;Visual&#32;Studio&#32;Marketplace" /><meta property="og:title" content="All&#32;categories&#32;Extensions&#32;for&#32;Visual&#32;Studio&#32;in&#32;Marketplace" /><meta property="og:type" content="website" /><meta property="og:url" content="https://marketplace.visualstudio.com/search?target=VS&amp;category=All&#32;categories&amp;vsVersion=vs2019&amp;sortBy=Downloads" /><meta property="twitter:card" content="summary" /><meta property="twitter:site" content="@VisualStudio" /><meta property="twitter:creator" content="@VisualStudio" />
<meta http-equiv="X-UA-Compatible" content="IE=11;&#32;IE=10;&#32;IE=9;&#32;IE=8" />
    <link rel="SHORTCUT ICON" href="/favicon.ico" />

    
    <link data-bundlelength="134008" data-bundlename="commoncss" data-highcontrast="https://cdn.vsassets.io/v/M165_20200226.19/_cssbundles/HighContrast/vss-bundle-commoncss-vj655o1hnfUOcoYE35G6iKwF__jvib5jh8BF3gozBLpE=" data-includedstyles="Gallery3rdParty;Gallery" href="https://cdn.vsassets.io/v/M165_20200226.19/_cssbundles/Default/vss-bundle-commoncss-vL-DJsqEt7HKucnIhI60LUmPAA6nl9jmS6-EgwJfR9Sw=" rel="stylesheet" />
<link data-bundlelength="116152" data-bundlename="viewcss" data-highcontrast="https://cdn.vsassets.io/v/M165_20200226.19/_cssbundles/HighContrast/vss-bundle-viewcss-vdlgmvK3r7d2NJT2HxmrnSW5uGherQCq6dVLcVJGo_uE=" data-includedstyles="VSS.Controls" href="https://cdn.vsassets.io/v/M165_20200226.19/_cssbundles/Default/vss-bundle-viewcss-vu75e1r3CYt-i_9HTv9byA67VrRg063mttS0GgT3kje8=" rel="stylesheet" />
<script nonce="CpEkIfToSn0pIeHuRroUjg==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('startLoadBundleOuter-basejs'); }</script>
<script data-bundlelength="125076" data-bundlename="basejs" nonce="CpEkIfToSn0pIeHuRroUjg==" src="https://cdn.vsassets.io/bundles/vss-bundle-basejs-v9GpWWBnsWqhM23ijhK2HfAqLowTXGUqZLDRsBCZbkfY=" type="text/javascript"></script>
<script nonce="CpEkIfToSn0pIeHuRroUjg==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('endLoadBundleOuter-basejs'); }</script>


    
    <!-- JSLL script -->
    
    <script type="text/javascript"  nonce="CpEkIfToSn0pIeHuRroUjg==" >

        
                var haveConsent = false;
        

        var jsll_config = {};
        jsll_config.coreData = {};
        jsll_config.cookiesToCollect = ["_mkto_trk"];

        jsll_config.ix = {};
        if(haveConsent){
          jsll_config.ix.a = true;
          jsll_config.ix.g = true;
          jsll_config.syncMuid = true;
        }
        jsll_config.coreData.appId = "marketplace.visualstudio.com";

        var js_callback = function() {
          window.awa.init(jsll_config);
        };

        var jsll = document.createElement("script");
        jsll.type = "text/javascript";
        jsll.src = "//az725175.vo.msecnd.net/scripts/jsll-4.js";
        document.getElementsByTagName("head")[0].appendChild(jsll);
        jsll.onload = js_callback;
        jsll.onreadystatechange = function() {
          if (this.readyState === "complete") {
            js_callback();
          }
        };
    </script>
    
    <!-- End JSLL script -->

</head>
<body class="platform gallery ">    
    
            <div><div id='msccBanner' dir='ltr' data-site-name='marketplace.visualstudio.com' data-mscc-version='0.4.2' data-nver='aspnet-3.1.1' data-sver='0.1.2' class='cc-banner' role='alert' aria-labelledby='msccMessage'><div class='cc-container'><svg class='cc-icon cc-v-center' x='0px' y='0px' viewBox='0 0 44 44' height='30px' fill='none' stroke='currentColor'><circle cx='22' cy='22' r='20' stroke-width='2'></circle><line x1='22' x2='22' y1='18' y2='33' stroke-width='3'></line><line x1='22' x2='22' y1='12' y2='15' stroke-width='3'></line></svg> <span id='msccMessage' class='cc-v-center cc-text' tabindex='0'>This site uses cookies for analytics, personalized content and ads. By continuing to browse this site, you agree to this use.</span> <a href='https://go.microsoft.com/fwlink/?linkid=845480' target='_top' aria-label='Learn more about Microsoft&#39;s Cookie Policy' id='msccLearnMore' class='cc-link cc-v-center cc-float-right' data-mscc-ic='false'>Learn more</a></div></div></div>
    
        <!-- Google Tag Manager -->
        <noscript>
            <iframe src="//www.googletagmanager.com/ns.html?id=GTM-WT9XBK"
                height="0" width="0" style="display: none; visibility: hidden"></iframe>
        </noscript>
        <script type="text/javascript"  nonce="CpEkIfToSn0pIeHuRroUjg==">(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
            new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
            j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
            '//www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
            })(window,document,'script','dataLayer','GTM-WT9XBK');</script>
        <!-- End Google Tag Manager -->
    
    <!-- GreenId -->
    <iframe  style="color:rgb(0,0,0);  float:left; position:absolute; top:-200px; left:-200px; border:0px" src="https://fpt.microsoft.com/tags?session_id=07b2425c-4f80-47e1-8e90-ac9d6fc27e3c" height=100  width=100 aria-hidden="true"></iframe>
    <!-- End GreenId -->
    
    <script type="text/javascript" nonce="CpEkIfToSn0pIeHuRroUjg=="> var __vssPageContext = {"webContext":{"host":{"id":"2663b13f-50e3-a655-a159-22f6f4725fab","name":"TEAM FOUNDATION","uri":"https://marketplace.visualstudio.com/","relativeUri":"/","hostType":"deployment","scheme":"https","authority":"marketplace.visualstudio.com"}},"moduleLoaderConfig":{"baseUrl":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/min/","paths":{"VSS/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","VSSPreview/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","Charts/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","Engagement/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","Gallery/Scripts/Gallery/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","ContentRendering/Resources":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","highcharts":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts.v7.2.1","highcharts/highcharts-more":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-more.v7.2.1","highcharts/modules/accessibility":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-accessibility.v7.2.1","highcharts/modules/funnel":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-funnel.v7.2.1","highcharts/modules/heatmap":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-heatmap.v7.2.1"},"map":{"*":{"office-ui-fabric-react/lib":"OfficeFabric"}},"contributionPaths":{"VSS":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/VSS","pathType":"default"},"VSS/Resources":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","pathType":"resource"},"q":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/q","pathType":"default"},"knockout":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/knockout","pathType":"default"},"mousetrap":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/mousetrap","pathType":"default"},"mustache":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/mustache","pathType":"default"},"react":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/react.15.3","pathType":"default"},"react-dom":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/react-dom.15.3","pathType":"default"},"react-transition-group":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/react-transition-group.15.3","pathType":"default"},"jQueryUI":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/jQueryUI","pathType":"default"},"jquery":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/jquery","pathType":"default"},"OfficeFabric":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/OfficeFabric","pathType":"default"},"tslib":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/tslib","pathType":"default"},"@uifabric":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/@uifabric","pathType":"default"},"VSSUI":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/VSSUI","pathType":"default"},"Charts":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/Charts","pathType":"default"},"Charts/Resources":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","pathType":"resource"},"ContentRendering":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/ContentRendering","pathType":"default"},"ContentRendering/Resources":{"value":"/_static/tfs/M165_20200226.19/_scripts/TFS/min/sv-SE","pathType":"resource"},"highcharts":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts.v7.2.1","pathType":"thirdParty"},"highcharts/highcharts-more":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-more.v7.2.1","pathType":"thirdParty"},"highcharts/modules/accessibility":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-accessibility.v7.2.1","pathType":"thirdParty"},"highcharts/modules/funnel":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-funnel.v7.2.1","pathType":"thirdParty"},"highcharts/modules/heatmap":{"value":"https://cdn.vsassets.io/3rdParty/_scripts/highcharts-heatmap.v7.2.1","pathType":"thirdParty"}},"shim":{"jquery":{"deps":[],"exports":"jQuery"}},"waitSeconds":30},"coreReferences":{"stylesheets":[{"url":"/_static/tfs/M165_20200226.19/_cssbundles/Default/vss-bundle-ext-core-css-vgEHbWqZ4eb0vmOdl2cWjkpPtqcsX1GJCq4DnY78oN3s=","highContrastUrl":null,"isCoreStylesheet":true}],"scripts":[{"identifier":"JQuery","url":"https://cdn.vsassets.io/3rdParty/_scripts/jquery-2.2.4.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"JQueryXDomain","url":"https://cdn.vsassets.io/3rdParty/_scripts/jquery.xdomainrequest.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"Promise","url":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/min/promise.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"GlobalScripts","url":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/min/global-scripts.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"LoaderFixes","url":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/pre-loader-shim.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":false},{"identifier":"AMDLoader","url":"https://cdn.vsassets.io/3rdParty/_scripts/require.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},{"identifier":"LoaderFixes","url":"https://cdn.vsassets.io/v/M165_20200226.19/_scripts/TFS/post-loader-shim.min.js","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":false}],"coreScriptsBundle":{"identifier":"CoreBundle","url":"/_public/_Bundling/Content?bundle=vss-bundle-basejs-v9GpWWBnsWqhM23ijhK2HfAqLowTXGUqZLDRsBCZbkfY=","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true},"extensionCoreReferences":{"identifier":"CoreBundle","url":"https://cdn.vsassets.io/bundles/vss-bundle-ext-core-vyAIky6p-ZuRPHK7Kca4boLAcs1hYjjgZbWBioqvGUPY=","fallbackUrl":null,"fallbackCondition":null,"isCoreModule":true}},"webAccessConfiguration":{"isHosted":true,"paths":{"rootPath":"/","staticContentRootPath":"/","staticContentVersion":"M165_20200226.19","resourcesPath":"https://cdn.vsassets.io/v/M165_20200226.19/_content/","staticRootTfs":"https://cdn.vsassets.io/v/M165_20200226.19/","cdnFallbackStaticRootTfs":"/_static/tfs/M165_20200226.19/","staticRoot3rdParty":"https://cdn.vsassets.io/3rdParty/"},"api":{"webApiVersion":"1","areaPrefix":"_","controllerPrefix":"_"},"mailSettings":{"enabled":false},"registryItems":{}},"microsoftAjaxConfig":{"cultureInfo":{"name":"sv-SE","numberFormat":{"CurrencyDecimalDigits":2,"CurrencyDecimalSeparator":",","IsReadOnly":true,"CurrencyGroupSizes":[3],"NumberGroupSizes":[3],"PercentGroupSizes":[3],"CurrencyGroupSeparator":" ","CurrencySymbol":"kr","NaNSymbol":"¤¤¤","CurrencyNegativePattern":8,"NumberNegativePattern":1,"PercentPositivePattern":0,"PercentNegativePattern":0,"NegativeInfinitySymbol":"-∞","NegativeSign":"-","NumberDecimalDigits":2,"NumberDecimalSeparator":",","NumberGroupSeparator":" ","CurrencyPositivePattern":3,"PositiveInfinitySymbol":"∞","PositiveSign":"+","PercentDecimalDigits":2,"PercentDecimalSeparator":",","PercentGroupSeparator":" ","PercentSymbol":"%","PerMilleSymbol":"‰","NativeDigits":["0","1","2","3","4","5","6","7","8","9"],"DigitSubstitution":1},"dateTimeFormat":{"AMDesignator":"","Calendar":{"MinSupportedDateTime":"0001-01-01T00:00:00","MaxSupportedDateTime":"9999-12-31T23:59:59.9999999","AlgorithmType":1,"CalendarType":1,"Eras":[1],"TwoDigitYearMax":2029,"IsReadOnly":true},"DateSeparator":"-","FirstDayOfWeek":1,"CalendarWeekRule":2,"FullDateTimePattern":"'den 'd MMMM yyyy HH:mm:ss","LongDatePattern":"'den 'd MMMM yyyy","LongTimePattern":"HH:mm:ss","MonthDayPattern":"'den 'd MMMM","PMDesignator":"","RFC1123Pattern":"ddd, dd MMM yyyy HH':'mm':'ss 'GMT'","ShortDatePattern":"yyyy-MM-dd","ShortTimePattern":"HH:mm","SortableDateTimePattern":"yyyy'-'MM'-'dd'T'HH':'mm':'ss","TimeSeparator":":","UniversalSortableDateTimePattern":"yyyy'-'MM'-'dd HH':'mm':'ss'Z'","YearMonthPattern":"MMMM yyyy","AbbreviatedDayNames":["sön","mån","tis","ons","tor","fre","lör"],"ShortestDayNames":["sö","må","ti","on","to","fr","lö"],"DayNames":["söndag","måndag","tisdag","onsdag","torsdag","fredag","lördag"],"AbbreviatedMonthNames":["jan","feb","mar","apr","maj","jun","jul","aug","sep","okt","nov","dec",""],"MonthNames":["januari","februari","mars","april","maj","juni","juli","augusti","september","oktober","november","december",""],"IsReadOnly":true,"NativeCalendarName":"Gregoriansk kalender","AbbreviatedMonthGenitiveNames":["jan","feb","mar","apr","maj","jun","jul","aug","sep","okt","nov","dec",""],"MonthGenitiveNames":["januari","februari","mars","april","maj","juni","juli","augusti","september","oktober","november","december",""]},"numberShortForm":{"QuantitySymbols":["K","M","B"],"NumberGroupSize":1000,"ThousandSymbol":"K"},"eras":null}},"timeZonesConfiguration":{},"featureAvailability":{"featureStates":{"VisualStudio.Services.Contribution.EnableOnPremUnsecureBrowsers":false,"VisualStudio.Service.WebPlatform.ClientErrorReporting":true,"Microsoft.VisualStudio.Services.Gallery.Client.UseCdnAssetUri":false,"VisualStudio.Services.WebAccess.SubresourceIntegrity":false,"VisualStudio.Services.IdentityPicker.ReactProfileCard":true,"Microsoft.VisualStudio.Services.Gallery.EnableVersionRangeOnSearchPage":true,"Microsoft.VisualStudio.Services.Gallery.TileImpressionsSearchPage":false,"Microsoft.VisualStudio.Services.Gallery.ShowPublishExtensions":true,"Microsoft.VisualStudio.Services.Gallery.ZeroSearchResultExperience":true,"Microsoft.VisualStudio.Services.Gallery.EnableVsForMac":false,"Microsoft.VisualStudio.Services.Gallery.EnableCertifiedPublisherUIChanges":true,"Microsoft.VisualStudio.Services.Gallery.EnableSortByInstallCountUI":true,"Microsoft.VisualStudio.Services.Gallery.RatingReview":true,"Microsoft.VisualStudio.Services.Gallery.EnableQueriesBasedOnHiddenFlags":true,"Microsoft.VisualStudio.Services.Gallery.EnableStickyBannerOnDetailsPage":true,"VisualStudio.Services.WebPlatform.UseNewBranding":true}},"appInsightsConfiguration":{"enabled":false,"instrumentationKey":"00000000-0000-0000-0000-000000000000","insightsScriptUrl":null},"diagnostics":{"sessionId":"07b2425c-4f80-47e1-8e90-ac9d6fc27e3c","activityId":"07b2425c-4f80-47e1-8e90-ac9d6fc27e3c","bundlingEnabled":true,"cdnAvailable":true,"cdnEnabled":true,"webPlatformVersion":"M165","serviceVersion":"Dev18.M165.1 (build: AzureDevOps_M165_20200313.1)"},"navigation":{"topMostLevel":"deployment","area":"","currentController":"Gallery","currentAction":"Search","commandName":"Gallery.Search","routeId":"LegacyWebAccessRoute","routeValues":{"controller":"Gallery","action":"Search","serviceHost":"2663b13f-50e3-a655-a159-22f6f4725fab (TEAM FOUNDATION)"}},"globalization":{"explicitTheme":"","theme":"Default","culture":"sv-SE","timezoneOffset":0,"timeZoneId":"UTC"},"serviceInstanceId":"00000029-0000-8888-8000-000000000000","hubsContext":{},"serviceLocations":{"locations":{"951917ac-a960-4999-8464-e3f0aa25b381":{"Application":"https://app.vssps.visualstudio.com/","Deployment":"https://app.vssps.visualstudio.com/"}}}};</script><script type="text/javascript" nonce="CpEkIfToSn0pIeHuRroUjg=="> var __cultureInfo = __vssPageContext.microsoftAjaxConfig.cultureInfo;</script>
<script type="text/javascript" nonce="CpEkIfToSn0pIeHuRroUjg=="> (function(){
var unloadStarted = false;
function onRequireError(e) {
    var msg = 'There was an error loading a required file. Would you like to reload the page to try to load again?';
    function reload(prompted) {
        document.cookie = 'TFS-CDN=disabled;max-age=28800;path=/;secure';
        document.cookie = 'TFS-CDNTRACE=report-'+prompted+'-'+(e.requireType === 'requirenotloaded' ? 'require' : encodeURIComponent(JSON.stringify(e.requireModules)))+';path=/;secure';
        document.location.reload(true);
    }
    if (!e || !e.requireType || (e.requireType !== 'scripterror' && e.requireType !== 'requirenotloaded')) {
        throw e;
    }
    if (unloadStarted) {
        return;
    }
    if (!window.requiredModulesLoaded) {
        reload(false);
    }
    else if (window.require && require.defined('VSS/Controls/Dialogs')) {
        require(['VSS/Controls/Dialogs'], function(d) {
            d.showMessageDialog(msg, { title: 'Network Error', buttons: [d.MessageDialog.buttons.yes, d.MessageDialog.buttons.no] }).then(function() { reload(true) });
        });
    }
    else {
        if (confirm(msg)) {
            reload(true);
        }
    }
}
window.addEventListener('beforeunload', function() {
    unloadStarted = true;
});
if (window.requirejs) {
    requirejs.onError = onRequireError;
}
else {
    onRequireError({requireType:'requirenotloaded'});
}
})();require.config(__vssPageContext.moduleLoaderConfig);</script>

    <script nonce="CpEkIfToSn0pIeHuRroUjg==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('startLoadBundleOuter-common'); }</script>
<script data-bundlelength="1136561" data-bundlename="common" data-includedscripts="VSS/Fonts/TextFonts;VSS/Fonts/IconFonts;Gallery/Client/Pages/Common/Base.View;Gallery/Client/Common/Telemetry;Gallery/Client/Controls/ErrorControl/ErrorControl.View;Gallery/Client/Service/VSSGallery/VSSGallery;Gallery/Client/Service/VSGallery/VSGallery;VSS/FeatureAvailability/RestClient;VSS/Error;VSS/Bundling" nonce="CpEkIfToSn0pIeHuRroUjg==" src="https://cdn.vsassets.io/bundles/vss-bundle-common-vKxxTjaOwoqlwBx1Uo3cCU7QYbXF27kVCHD-PknU6hdc=" type="text/javascript"></script>
<script nonce="CpEkIfToSn0pIeHuRroUjg==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('endLoadBundleOuter-common'); }</script>
<script nonce="CpEkIfToSn0pIeHuRroUjg==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('startLoadBundleOuter-view'); }</script>
<script data-bundlelength="301490" data-bundlename="view" data-includedscripts="Gallery/Client/Pages/Category/Category.View;VSS/Error" nonce="CpEkIfToSn0pIeHuRroUjg==" src="https://cdn.vsassets.io/bundles/vss-bundle-view-vHWXZlcmtPJ4K1xWN7HFw4Z9_4Vo6m_1mCW2Eju7gNa8=" type="text/javascript"></script>
<script nonce="CpEkIfToSn0pIeHuRroUjg==" type="text/javascript">if (window.performance && window.performance.mark) { window.performance.mark('endLoadBundleOuter-view'); }</script>

<script type="text/javascript" nonce="CpEkIfToSn0pIeHuRroUjg=="> if (window.performance && window.performance.mark) { window.performance.mark('requireStart'); }
require(["VSS/Fonts/TextFonts","VSS/Fonts/IconFonts","Gallery/Client/Pages/Category/Category.View","Gallery/Client/Pages/Common/Base.View","Gallery/Client/Common/Telemetry","Gallery/Client/Controls/ErrorControl/ErrorControl.View","Gallery/Client/Service/VSSGallery/VSSGallery","Gallery/Client/Service/VSGallery/VSGallery","VSS/FeatureAvailability/RestClient","VSS/Error"], function(){  if (window.performance && window.performance.mark) { window.performance.mark('requireEnd'); } window.requiredModulesLoaded=true;  });
</script>


    
    <a href="#start-of-content" class="skip-main">Skip to content</a>  
    <div class="page-content">
        <div class="header-section">
            
            <div class="uxservices-header" role="banner">
                <div id="ux-header">
                <div class="upperBand">
                    <div class="upperBandContent marketplace-header">
                        <a href="/" title="Marketplace" class="left" >  
                            <div class="marketPlaceLogoLink bowtie-icon bowtie-brand-visualstudio vs-brand-icon menu-item-icon"></div>
                            <div class="visualStudioLogoLink"> Visual Studio  </div>
                            <div id="marketPlaceLogoLink" class="marketPlaceLogoLink">|   Marketplace</div>
                        </a>
                        <div class="right">
                             
                            <div id="signIn">
                                
                                    <a href="https://app.vssps.visualstudio.com/_signin?realm=marketplace.visualstudio.com&amp;reply_to=https%3A%2F%2Fmarketplace.visualstudio.com%2Fsearch%3Ftarget%3DVS%26category%3DAll%2520categories%26vsVersion%3Dvs2019%26sortBy%3DDownloads&amp;redirect=1&amp;context=eyJodCI6MywiaGlkIjoiMjY2M2IxM2YtNTBlMy1hNjU1LWExNTktMjJmNmY0NzI1ZmFiIiwicXMiOnt9LCJyciI6IiIsInZoIjoiIiwiY3YiOiIiLCJjcyI6IiJ90&amp;workflowId=marketplace&amp;wt.mc_id=o~msft~marketplace~signIn#ctx=eyJTaWduSW5Db29raWVEb21haW5zIjpbImh0dHBzOi8vbG9naW4ud2luZG93cy5uZXQiLCJodHRwczovL2xvZ2luLm1pY3Jvc29mdG9ubGluZS5jb20iXX01" class="scarabLink" style="float:left;margin-left:23px;padding-top:1px;color:#fff;font-weight:400;">
                                        Sign in
                                    </a>
                                
                            </div>                            
                            <div data-fragmentname="SearchBox" id="Fragment_SearchBox">
                              <div class="SearchBox" role="search">
                                <form id="HeaderSearchForm" name="HeaderSearchForm" method="get">
                                  <input id="HeaderSearchTextBox" aria-label="search" name="query" type="text" maxlength="200" autocomplete="off">
                                  <input id="RefinementId" name="refinement" type="hidden" value="198">
                                  <button class="bowtie-icon bowtie-search header-search-button" id="HeaderSearchButton" value="" type="submit"></button>
                                </form>
                                <a id="search-box" class="bowtie-icon bowtie-search metroSearchButton" tabindex="0" title="Search here" role="button"></a>
                              </div>  
                            </div>
                        </div>
                    </div>
                </div>
            </div>
                
            </div>
            
        </div>
        <div class="skiptarget" id="start-of-content"></div>
        <div id="gallery-content">
            
    
    <script id="image-template" type="text/html">
    <img class="image-display" alt="" data-bind="attr: { src: imageSrc}, css: imageStyle, visible: imageVisible" />
    <div class="bowtie-icon" data-bind="visible: (!imageVisible && !bowtieStyle), css: bowtieStyle "></div>
    <span data-bind="template: { afterRender: componentLoaded($element) }"></span>
</script><script id="gallery-item-card-template" type="text/html">
    <a class="gallery-item-card-container" data-bind="attr: { href: link, target: linkTarget, 'aria-label': getScreenReaderText(), tabindex: getTabindex() }, click: itemTileClick()">
        <div class="gallery-item-card" data-bind="attr: { link: itemClassName, title: title}">
            <div class="cover">
                <!-- ko if: showCertifiedBadge -->
                <i class="active-user-info certified-badge-image" data-bind="attr: { title: certifiedBadgeText }, text: certifiedBadgeIcon" />
                <!-- /ko -->
                <div class="icon-cell" data-bind="renderRegisteredTemplate: { templateName: 'new-image-template', data: imageViewModelOption() }, attr: { title: title }"></div>
                <div class="core-info-cell">
                    <div class="name">
                        <span class="item-title" data-bind="text: title" />
                        <!-- TextFadeout based on extension title. MaxWidth of title: 158px and Fadeout width: 30px -->
                        <span class="text-fadeout" data-bind="style: {width: calculateWidthBasedOnSibling($element, 'item-title', 158, '30px')}" />
                    </div>
                    <!--ko ifnot: showInstallCount -->
                    <div class="publisher">
                        <span data-bind="text: publisher, attr: { title: publisher }"> </span>
                    </div>
                    <span class="text-fadeout"></span>
                    <!-- /ko -->
                    <!--ko if: showInstallCount -->
                    <div class="core-info-second-row">
                        <span class="installs" data-bind="visible: installCount !== '0'">
                            <i class="bowtie-icon bowtie-install install-icon" />
                            <span class="install-count" data-bind="text: installCount"></span>
                        </span>
                        <div class="publisher">
                            <span data-bind="text: publisher, attr: { title: publisher }" />
                            <span class="text-fadeout" />
                        </div>
                    </div>
                    <!-- /ko -->
                </div>
            </div>
            <div class="details">
                <div class="description" data-bind="text: description, attr: { title: description }" />
            </div>
            <div class="stats-and-offer">
                <!-- ko if: showRatingReview -->
                <div class="rating-and-price">
                    <div role="img" class="rating" data-bind="template: { name: 'rating-control-page-template', data: ratingViewModel }, attr: { 'alt': averageRatingText, title: averageRatingText }"></div>
                    <div class="pricing-tag" data-bind="text: pricingTag, attr: { title: pricingTag }"></div>
                    <span class="text-fadeout" />
                </div>
                <!-- /ko -->
                <!-- ko ifnot: showRatingReview -->
                <div class="pricing-tag" data-bind="text: pricingTag, attr: { title: pricingTag }"></div>
                <span class="text-fadeout" />
                <!-- /ko -->
            </div>
        </div>
    </a>
</script>
<script id="rating-control-page-template" type="text/html">
    <span class="rating-control">
        <!-- ko foreach: fullStarArray() -->
        <img class="star full-star" alt="" data-bind="event: {click: $parent.fullStarClick($index()),
                                                       mouseover: $parent.fullStarMouseOver($index()), 
                                                       mouseout: $parent.fullStarMouseOut(),
                                                       keypress: $parent.fullStarKeyPress($index())},
                                                       attr: {tabindex: $parent.starTabIndex(), src: $parent.fullStarPath, 'aria-label': $index()+1+' star' }" />
        <!-- /ko -->

        <!-- ko if: isReadOnly-->
        <!-- ko foreach: halfStarArray() -->
        <img class="star half-star" alt="" data-bind="attr: {tabindex: $parent.starTabIndex(), src: $parent.halfStarPath}" />
        <!-- /ko -->
        <!-- /ko -->

        <!-- ko foreach: emptyStarArray() -->
        <img class="star empty-star" alt="" data-bind="event: {click: $parent.emptyStarClick($index()),
                                                        mouseover:$parent.emptyStarMouseOver($index()), 
                                                        keypress: $parent.emptyStarKeyPress($index())},
                                                        attr: {tabindex: $parent.starTabIndex(), src: $parent.emptyStarPath, 'aria-label': $index()+1+$parent.fixedFullStars()+' star'}" />
        <!-- /ko -->
    </span>

</script><script id="item-card-template" type="text/html">
        <div class="item-entry-wrapper" data-bind="template: { name: 'gallery-item-card-template' }, click: function(data, event) {return $data.onClick(data, event)}">
        </div>
</script><script id="item-banner-template" type="text/html">
    <div class="item-banner-root" data-bind="css: itemCss">
        <table class="item-banner" role="presentation">
            <tr>
                <td class="item-header" data-bind="style: { 'background-color': brandingColor }, css: brandingTheme">
                    <div class="item-header-content">
                        <div class="ux-item-name" data-bind="text: title"></div>
                        <div class="ux-item-description" data-bind="text: publisherDisplay"></div>
                    </div>
                </td>
            </tr>
        </table>
    </div>
</script><script id="item-grid-template" type="text/html">
    <div class="item-grid-container" data-bind="foreach: itemArray">
        <div data-bind="template: { name: $parent.itemDisplayTemplate, data: $data }"></div>
    </div>
</script><script id="item-row-template" type="text/html">
        <div class="item-row-container" data-bind="foreach: _itemArray, attr: { id: $data._itemRowId }, event: { keydown: _itemRowKeyHandler }" style="overflow: auto">
            <div data-bind="template: { name: $parent._itemDisplayTemplate, data: $data }, css: 'row-item'"></div>
        </div>
        <span data-bind="template: { afterRender: _postRenderCallback }"></span>
</script><script id="categorized-list-template" type="text/html">
<div data-bind ="foreach: itemsByCategoryList">
    <div class="categorized-list gallery-item-cluster clearfix" >
        <div class="header-container">
            <a class="section-header gallery-element-focus-style-light name" data-bind="attr: {href: categoryLink},text: categoryName, css: { disabled: !categoryLink }" />
            <a class="see-more" data-bind="attr: {href: categoryLink}, visible:hasMoreExtension , text: categoryLinkTitle" />
        </div>
        <div class="item-list-container clearfix" data-bind="renderRegisteredTemplate: { templateName: categoryItemsTemplate, data: categoryItems }"></div>         
    </div>
</div>
</script>
<script id="category-control-template" type="text/html">
    <div class="category-container">
        <div class="filters-container">
            <div class="gallery-centered-content" role="navigation">
                <!-- ko if: !isHosted -->
                <table>
                    <tbody>
                        <tr>
                            <td>
                                <table>
                                    <tbody>
                                        <tr>
                                            <td class="navigate-back-container">
                                                <a data-bind="attr: { href: _koExtensionsUrl }">
                                                    <div class="extension-url">
                                                        <span class="bowtie-icon bowtie-arrow-left"></span>
                                                        <span data-bind="text: extensionsLinkText"></span>
                                                    </div>
                                                </a>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </td>
                            <td>
                                <div class="filter-control-container"></div>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <!-- /ko -->
                <!-- ko if: isHosted -->
                <table>
                    <tbody>
                        <tr class="tab-collection" role="tablist">
                            <td class="tab VS gallery-element-focus-style-dark" role="tab"
                                data-bind="click: $data.vsTabClick(), hasfocus: isVSTabFocused, attr: { 'aria-controls': $data.getAriaControls($data.vsTabName), 'aria-selected': $data.getAriaSelected($data.vsTabName), tabindex: $data.getTabIndex($data.vsTabName) }, event: { keydown: $data.vsTabKeyDown() }, css: { tabactive: $data.isTabActive($data.vsTabName) }">
                                <div class="header" data-bind="title: VS_Header, text: VS_Header"></div>
                            </td>
                            <!-- ko if: showVSForMac -->
                                <td class="tab VSForMac gallery-element-focus-style-dark" role="tab"
                                data-bind="click: $data.vsformacTabClick(), hasfocus: isVSForMacTabFocused, attr: { 'aria-controls':  $data.getAriaControls($data.vsForMacTabName), 'aria-selected': $data.getAriaSelected($data.vsForMacTabName), tabindex: $data.getTabIndex($data.vsForMacTabName) }, event: { keydown: vsForMacTabKeyDown() }, css: { tabactive: $data.isTabActive($data.vsForMacTabName) }">
                                    <div class="header" data-bind="title: VSForMac_Header, text: VSForMac_Header"></div>
                                </td>
                                <td class="tab VSCode gallery-element-focus-style-dark" role="tab"
                                    data-bind="click: $data.vsCodeTabClick(), hasfocus: isVSCodeTabFocused, attr: { 'aria-controls': $data.getAriaControls($data.vsCodeTabName), 'aria-selected': $data.getAriaSelected($data.vsCodeTabName), tabindex: $data.getTabIndex($data.vsCodeTabName) }, event: { keydown: $data.vsCodeTabKeyDown() }, css: { tabactive:  $data.isTabActive($data.vsCodeTabName) }">
                                    <div class="header" data-bind="title: VSCode_Header, text: VSCode_Header"></div>
                                </td>
                                <td class="tab VSS gallery-element-focus-style-dark" role="tab"
                                    data-bind="click: $data.vstsTabClick(), hasfocus: isVSTSTabFocused, attr: { 'aria-controls': $data.getAriaControls($data.vstsTabName), 'aria-selected': $data.getAriaSelected($data.vstsTabName), tabindex: $data.getTabIndex($data.vstsTabName) }, event: { keydown: $data.vstsTabKeyDown() }, css: { tabactive:  $data.isTabActive($data.vstsTabName) }">
                                    <div class="header" data-bind="title: VSTS_Header, text: VSTS_Header"></div>
                                </td>
                            <!-- /ko -->
                            <!-- ko ifnot: showVSForMac -->
                                <!-- ko ifnot: newBranding -->
                                    <td class="tab VSS gallery-element-focus-style-dark" role="tab"
                                        data-bind="click: $data.vstsTabClick(), hasfocus: isVSTSTabFocused, attr: { 'aria-controls': $data.getAriaControls($data.vstsTabName), 'aria-selected': $data.getAriaSelected($data.vstsTabName), tabindex: $data.getTabIndex($data.vstsTabName) }, event: { keydown: $data.vstsTabKeyDown() }, css: { tabactive:  $data.isTabActive($data.vstsTabName) }">
                                        <div class="header" data-bind="title: VSTS_Header, text: VSTS_Header"></div>
                                    </td>
                                    <td class="tab VSCode gallery-element-focus-style-dark" role="tab"
                                        data-bind="click: $data.vsCodeTabClick(), hasfocus: isVSCodeTabFocused, attr: { 'aria-controls': $data.getAriaControls($data.vsCodeTabName), 'aria-selected': $data.getAriaSelected($data.vsCodeTabName), tabindex: $data.getTabIndex($data.vsCodeTabName) }, event: { keydown: $data.vsCodeTabKeyDown() }, css: { tabactive:  $data.isTabActive($data.vsCodeTabName) }">
                                        <div class="header" data-bind="title: VSCode_Header, text: VSCode_Header"></div>
                                    </td>
                                <!-- /ko -->
                                <!-- ko if: newBranding -->
                                    <td class="tab VSCode gallery-element-focus-style-dark" role="tab"
                                        data-bind="click: $data.vsCodeTabClick(), hasfocus: isVSCodeTabFocused, attr: { 'aria-controls': $data.getAriaControls($data.vsCodeTabName), 'aria-selected': $data.getAriaSelected($data.vsCodeTabName), tabindex: $data.getTabIndex($data.vsCodeTabName) }, event: { keydown: $data.vsCodeTabKeyDown() }, css: { tabactive:  $data.isTabActive($data.vsCodeTabName) }">
                                        <div class="header" data-bind="title: VSCode_Header, text: VSCode_Header"></div>
                                    </td>
                                    <td class="tab VSS gallery-element-focus-style-dark" role="tab"
                                        data-bind="click: $data.vstsTabClick(), hasfocus: isVSTSTabFocused, attr: { 'aria-controls': $data.getAriaControls($data.vstsTabName), 'aria-selected': $data.getAriaSelected($data.vstsTabName), tabindex: $data.getTabIndex($data.vstsTabName) }, event: { keydown: $data.vstsTabKeyDown() }, css: { tabactive:  $data.isTabActive($data.vstsTabName) }">
                                        <div class="header" data-bind="title: VSTS_Header, text: VSTS_Header"></div>
                                    </td>                                
                                <!-- /ko -->                                
                            <!-- /ko -->
                            <td class="tab VSSubs gallery-element-focus-style-dark" role="tab"
                                data-bind="click: $data.vsSubTabClick(), hasfocus: isVSSubsTabFocused, attr: { 'aria-controls': $data.getAriaControls($data.vsSubsTabName), 'aria-selected': $data.getAriaSelected($data.vsSubsTabName), tabindex: $data.getTabIndex($data.vsSubsTabName)}, event: { keydown: $data.vsSubTabKeyDown() }, css: { tabactive:  $data.isTabActive($data.vsSubsTabName) }">
                                <div class="header" data-bind="title: Subs_Header, text: Subs_Header"></div>
                            </td>
                            <td class="tab-right gallery-element-focus-style-dark" tabindex="-1">
                                <a id="publish-extensions" class="publish-extensions" target="_blank" data-bind="attr: { href: $data.getBuildYourOwnURL() }, click: $data.buildYourOwnLinkClick(), text: BuildYourOwnText" href="https://go.microsoft.com/fwlink/?LinkID=703826"></a>
                                <!-- ko if: $data.showPublishExtensions -->
                                <a class="publish-extensions" target="_blank" data-bind="attr: { href: $data.getPublishExtensionsUrl() }, click: $data.publishExtensionsClick(), text: PublishExtensionsText"></a>
                                <!-- /ko -->
                            </td>
                        </tr>
                    </tbody>
                </table>
                <!-- /ko -->
            </div>
        </div>
        <div id="page-content" class="category-items-container gallery-centered-content" role="main">
            <!-- ko if: isHosted -->
            <div class="searchbar-container" data-bind="visible: isHosted"></div>
            <!-- /ko -->
            <div class="categorized-list gallery-item-cluster clearfix" data-bind="attr: {id: categoryListId}">
                <div class="header-container">
                    <div class="section-header gallery-element-focus-style-light name">
                        <!-- ko if: !isHosted -->
                        <span class="query-category" data-bind="if: _koSearchQueryOrCategoryHeader, text: _koSearchQueryOrCategoryHeader" />
                        <!-- /ko -->
                        <!-- ko if: _koResultsFoundText -->
                        <span role="heading" aria-level="2" class="results-found" aria-live="assertive" data-bind="text: _koResultsFoundText, visible: isHosted" />
                        <!-- /ko -->
                    </div>
                    <div class="filters-container" data-bind="visible: _koIsShowFilterControl">
                        <div class="filter-control-container"></div>
                    </div>
                </div>
                <div class="item-list-container clearfix"></div>
                <div class="see-more-container"></div>
                <div class="spinner-container">
                    <i class="big-spinner bowtie-icon bowtie-spinner" data-bind="css: { centered: styleFirstSpinner }, visible: _koShowSpinner"></i>
                </div>
                <div class="no-results-text" data-bind="if: _koShowSuggestions">
                    <div class="no-results-suggestion" data-bind="text: suggestionsText" />
                    <ul class="suggestion-list" data-bind="foreach: suggestionsList">
                        <li data-bind="html: $data"></li>
                    </ul>
                </div>
                <div class="zero-results-container" data-bind="visible: _koShowNewZeroResultExperience">
                    <div class="zero-results-control-container">
                    </div>
                </div>
            </div>
        </div>
</script>
<script id="bread-crumb-template" type="text/html">
    <span class="bread-crumb-container" data-bind="foreach: members, event: { keydown: breadcrumbKeyHandler}">
        <!-- ko if: url -->
        <a class="member" data-bind="text: text, attr: {href: url}"></a>
        <!-- /ko -->
        <!-- ko if: !url -->
        <span class="member" data-bind="text: text"></span>
        <!-- /ko -->  
        <!-- Do not draw seprarator after the last member -->
        <span class="separator" data-bind="if: $index() < $parent.members.length-1">></span>
    </span>
</script>
<script id="error-control-template" type="text/html">
    <div class="gallery-error-control">
        <div class="error-text" data-bind="text: errorText"></div>
        <div class="tips-header" data-bind="text: tipsText"></div>
        <div class="error-diagnosis" data-bind="html: errorDiagnosisHtml"></div>
        <div class="report-issue" data-bind="html: contactUsHtml, visible: isHosted"></div>
    </div>
</script><script id="filter-control-template" type="text/html">
    <table role="presentation">
        <tr data-bind="foreach: filters" role="menubar">
            <td>
                <div data-bind="attr: { id: $data.filterId }">
                    <span data-bind="text: $data.filterName, visible: $parent.isFilterNameVisible($data.filterName)" class="filter-title"></span>
                    <span class="filter-menu" data-bind="attr: { tabindex: $parent.isFilterMenuTabIndex($data.isCompleteFocus), 'aria-describedby': $data.ariaDescribedByIds, 'aria-labelledby': $data.ariaLabelledByIds, 'aria-label': $data.ariaLabel, 'aria-expanded': $data.isExpanded() }, css: {disabled: !($data.isEnabled() && $parent.isEnabled()) }" aria-haspopup="true" role="menuitem">
                        <span data-bind="css: {dropdown: $data.isDropDown()}, attr: {tabindex: $parent.isDropDownTabIndex($data.isEnabled(), $data.isCompleteFocus)}">
                            <span data-bind="attr: {title: $parent.getSelectedItemLabelForFilter($data.filterId)}, text: $parent.getSelectedItemLabelForFilter($data.filterId)" class="filter-value"></span>
                            <span data-bind="visible: $parent.isDropDownVisible($data.isEnabled(), $data.isDropDown )" class="bowtie-icon bowtie-chevron-down dropdown"></span>
                        </span>
                    </span>
                </div>
            </td>
        </tr>
    </table>
</script>
<script id="searchbar-control-template" type="text/html">
    <div class="searchbar" role="search">
        <input class="search-input" maxlength="200" data-bind="value: searchTerm, valueUpdate: 'keyup', enable: isEnabled(), attr: { 'aria-label': placeHolder, placeholder : placeHolder}, enterkey: submitSearchTerm" autocomplete="off"/>
        <span role="button" class="clearbutton bowtie-icon bowtie-math-multiply" data-bind="click: clearButtonClick(), visible: searchTerm().length > 0, spacekey: clearSearchTerm, enterkey: clearSearchTerm, attr: {title: clearSearchQuery}" tabindex="0"></span>
        <!-- EU Cookie Consent: Consider user consent on clicking the search button by setting data-mscc-ic attribute to true -->
        <span role="button" class="searchbutton gallery-element-focus-style-moderate bowtie-icon bowtie-search" data-bind="click: searchButtonClick(), spacekey: submitSearchTerm, enterkey: submitSearchTerm, attr: {title: searchButtonTitle}" tabindex="0" data-mscc-ic="true"></span>
    </div>
</script><script id="seemore-control-template" type="text/html">
    <div class="see-more-container">
        <a tabindex="0" class="see-more-text gallery-element-focus-style-light" data-bind="visible: isVisible(), text: seeMoreText, event: { mouseup: callMouseUp()}, enterkey: callback, click:callClick(), attr: {title: linkTitle}"/>
    </div>
</script>
<script id="zero-results-template" type="text/html">
    <div class="zero-results-control">
        <div class="zero-results-header" aria-live="polite">
            <img alt="" data-bind="attr: { src: _koNoResultsImagePath }" />
            <div data-bind="text: _koNoMatchTitle" />
        </div>

        <div id="articles-container" data-bind="visible: _koRelevantArticles().length > 0">
            <div class="zero-results-section-header articles-header">
                <span class="bowtie-icon bowtie-file-content zero-results-section-icon" />
                <span data-bind="text: _koRelevantArticlesTitle" />
            </div>
            <div class="relevant-articles-container" data-bind="foreach: _koRelevantArticles">
                <div class="article">
                    <a data-bind="attr: { href: $data.url }, text: $data.title, click: $parent._koArticleClick, enterkey: $parent._koArticleClick" target="_blank" rel="noreferrer noopener"></a>
                    <div class="article-description" data-bind="text: $data.description"></div>
                </div>
            </div>
            <div class="see-more-articles" data-bind="if: _koShouldShowSeeMore">
                <div class="see-more">
                    <a tabindex="0" data-bind="click: _koSeeMoreClick, enterkey: _koSeeMoreEnter">
                        <span data-bind="text: _koSeeMoreText" />
                        <span class="bowtie-icon bowtie-chevron-right-light" />
                    </a>
                </div>
            </div>
            <div class="relevant-articles-container" id="extra-articles" data-bind="css: { showList: _koShowExtraList() === true }, foreach: _koExtraRelevantArticles">
                <div class="article">
                    <a data-bind="attr: { href: $data.url }, text: $data.title, click: $parent._koArticleClick, enterkey: $parent._koArticleClick" target="_blank" rel="noreferrer noopener"></a>
                    <div class="article-description" data-bind="text: $data.description"></div>
                </div>
            </div>
        </div>

        <div class="zero-results-section-header">
            <span class="bowtie-icon bowtie-trigger zero-results-section-icon" />
            <span data-bind="text: _koSuggestionsTitle" />
        </div>
        <ul class="suggestions-list" data-bind="foreach: _koSuggestions">
            <li data-bind="html: $data"></li>
        </ul>

        <div class="zero-results-section-header">
            <span class="bowtie-icon bowtie-feedback zero-results-section-icon" />
            <span data-bind="text: _koFeedbackTitle" />
        </div>
        <div data-bind="visible: _koShowFeedbackForm">
            <div class="feedback-box-label" data-bind="text: _koFeedbackFormLabel"></div>
            <div class="feedback-box">
                <textarea aria-required="true" class="feedback-input" maxlength="390" data-bind="value: _koUserFeedback, valueUpdate: 'keyup', attr: { 'aria-label': _koFeedbackPlaceholder, placeholder : _koFeedbackPlaceholder }" autocomplete="off" />
            </div>
            <div>
                <button tabindex="0" class="submit-feedback-button" data-bind="disable: !_koUserFeedback, text: _koSubmitFeedbackButton, click: _koSubmitFeedback"></button>
            </div>
        </div>
        <div class="post-feedback-message" data-bind="visible: _koShowPostFeedbackMessage">
            <span class="bowtie-icon bowtie-status-success-outline" />
            <span data-bind="text: _koPostFeedbackText" />
        </div>
        
    </div>
</script><script id="new-image-template" type="text/html">
    <img class="image-display" alt="" data-bind="attr: { src: imageSrc }, css: imageStyle, visible: imageVisible" />
    <div class="bowtie-icon" data-bind="visible: isBowtieVisible(), css: bowtieStyle"></div>
</script>
    <div class="user-mail-data">
        <script class="UserMailAddress" defer="defer" type="application/json">null</script>
    </div>
    <div>
        <script class="product-categories" defer="defer" type="application/json">null</script>
        <script class="valid-categories" defer="defer" type="application/json">{"vscode":[{"cn":"Programming Languages","icn":"languages"},{"cn":"Snippets","icn":"snippets"},{"cn":"Themes","icn":"themes"},{"cn":"Linters","icn":"linters"},{"cn":"Debuggers","icn":"debuggers"},{"cn":"Other","icn":"other"},{"cn":"Keymaps","icn":"keymaps"},{"cn":"Formatters","icn":"formatters"},{"cn":"Extension Packs","icn":"extensionpacks"},{"cn":"SCM Providers","icn":"scmproviders"},{"cn":"Azure","icn":"azure"},{"cn":"Language Packs","icn":"languagepacks"}],"vsformac":[{"cn":"Other","icn":"other"},{"cn":"IDE Extensions","icn":"ideextensions"}],"vsts":[{"cn":"Other","icn":"other"},{"cn":"Azure Pipelines","icn":"azurepipelines"},{"cn":"Azure Boards","icn":"azureboards"},{"cn":"Azure Repos","icn":"azurerepos"},{"cn":"Azure Artifacts","icn":"azureartifacts"},{"cn":"Azure Test Plans","icn":"azuretestplans"}],"vs":[{"cn":"Templates","icn":"templates"},{"cn":"Controls","icn":"controls"},{"cn":"Tools","icn":"tools"},{"cn":"AJAX","pcn":"Templates","icn":"ajax"},{"cn":"ASP.NET","pcn":"Templates","icn":"aspnet"},{"cn":"Office","pcn":"Templates","icn":"office"},{"cn":"Windows Phone","pcn":"Templates","icn":"windowsphone"},{"cn":"Silverlight","pcn":"Templates","icn":"silverlight"},{"cn":"Database","pcn":"Templates","icn":"database"},{"cn":"WCF","pcn":"Templates","icn":"wcf"},{"cn":"Windows Forms","pcn":"Templates","icn":"windowsforms"},{"cn":"Workflow","pcn":"Templates","icn":"workflow"},{"cn":"WPF","pcn":"Templates","icn":"wpf"},{"cn":"ASP.NET","pcn":"Controls","icn":"aspnetcontrols"},{"cn":"Silverlight","pcn":"Controls","icn":"silverlightcontrols"},{"cn":"Sharepoint","pcn":"Controls","icn":"sharepointcontrols"},{"cn":"Windows Forms","pcn":"Controls","icn":"windowsformscontrols"},{"cn":"WPF","pcn":"Controls","icn":"wpfcontrols"},{"cn":"Framework \u0026 Libraries","pcn":"Controls","icn":"framework"},{"cn":"Build","pcn":"Tools","icn":"build"},{"cn":"Coding","pcn":"Tools","icn":"coding"},{"cn":"Data","pcn":"Tools","icn":"data"},{"cn":"Documentation","pcn":"Tools","icn":"documentation"},{"cn":"Modeling","pcn":"Tools","icn":"modeling"},{"cn":"Other","pcn":"Tools","icn":"othertools"},{"cn":"Performance","pcn":"Tools","icn":"performance"},{"cn":"Programming Languages","pcn":"Tools","icn":"programmingLanguages"},{"cn":"Reporting","pcn":"Tools","icn":"reporting"},{"cn":"Security","pcn":"Tools","icn":"security"},{"cn":"Setup \u0026 Deployment","pcn":"Tools","icn":"setup"},{"cn":"Source Control","pcn":"Tools","icn":"sourcecontrol"},{"cn":"Team Development","pcn":"Tools","icn":"teamdevelopment"},{"cn":"Testing","pcn":"Tools","icn":"testing"},{"cn":"Web","pcn":"Tools","icn":"web"},{"cn":"Visual Studio Extensions","pcn":"Templates","icn":"vsextensions"},{"cn":"Other","pcn":"Templates","icn":"othertemplates"},{"cn":"Start Pages","pcn":"Tools","icn":"startpages"},{"cn":"SharePoint","pcn":"Tools","icn":"SharePointtools"},{"cn":"SharePoint","pcn":"Templates","icn":"SharePointtemplates"},{"cn":"XNA Game Studio","pcn":"Templates","icn":"XNA Game Studio"},{"cn":"Process Templates","pcn":"Tools","icn":"Process Templates"},{"cn":"LightSwitch","pcn":"Controls","icn":"lightswitchcontrols"},{"cn":"LightSwitch","pcn":"Templates","icn":"lightswitchtemplates"},{"cn":"LightSwitch","pcn":"Tools","icn":"lightswitchtools"},{"cn":"Extension SDK","pcn":"Tools","icn":"ExtensionSDK"},{"cn":"Scaffolding","pcn":"Tools","icn":"tools_scaffolding"},{"cn":"Connected Services","pcn":"Tools","icn":"tools_connectedservices"},{"cn":"Services","pcn":"Tools","icn":"tools_services"},{"cn":"Extension Packs","pcn":"Tools","icn":"extensionpacksvs"},{"cn":"Themes","pcn":"Tools","icn":"tools_theme"}]}</script>
    </div>
    <div class="main-content category-main-content">
        <div class="category-content">
        </div>
    </div>

            <div class="general-info">
                <script class="general-info-data" defer="defer" type="application/json">{"galleryUrl":"/","resourcesPath":"https://cdn.vsassets.io/v/M165_20200226.19/_content/","isHosted":true}</script>
            </div>
        </div>
        
        <div id="gallery-footer">
            
<footer>
    
    <div id="ux-footer" class="ltr" role="contentinfo">
    
        <div id="baseFooter">
            <div data-fragmentname="BaseFooterLinks" id="Fragment_BaseFooterLinks" xmlns="http://www.w3.org/1999/xhtml">

                <div class="linkList">
                    <ul class="links horizontal">
                        <!-- EU Cookie Consent: Do not consider user consent on clicking any of the links, by setting data-mscc-ic attribute to false -->
                        <li>
                            <a href="https://www.visualstudio.com/support/support-overview-vs" data-mscc-ic="false">Contact us</a>
                        </li>
                        <li>
                            <a href="https://careers.microsoft.com/" data-mscc-ic="false">Jobs</a>
                        </li>
                        <li>
                            <a href="https://go.microsoft.com/fwlink/?LinkID=264782" data-mscc-ic="false">Privacy</a>
                        </li>
                        <li>
                            <a href="https://aka.ms/vsmarketplace-ToU" data-mscc-ic="false">Terms of use</a>
                        </li>
                        <li>
                            <a href="https://www.microsoft.com/en-us/legal/intellectualproperty/Trademarks/EN-US.aspx" data-mscc-ic="false">Trademarks</a>
                        </li>
                    </ul>
                </div>
            </div>
            <div id="rightBaseFooter">
                &copy; 2020 Microsoft
                <span class="microsoftLogo" title="Microsoft"></span>
            </div>
            <div class="clear"></div>
        </div>
    </div>
</footer>

        </div>
        
    </div>

    
    
    <div id="utils-accessibility-announce-polite" class="visually-hidden" aria-live="polite"></div>
    <div id="utils-accessibility-announce-assertive" class="visually-hidden" aria-live="assertive"></div>
</body>
</html>
